diff -Naur openssl-1.0.0q.orig/crypto/rc2/rc2test.c openssl-1.0.0q/crypto/rc2/rc2test.c
--- openssl-1.0.0q.orig/crypto/rc2/rc2test.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/rc2test.c	2017-04-25 16:23:40.624621283 +0200
@@ -59,9 +59,11 @@
 /* This has been a quickly hacked 'ideatest.c'.  When I add tests for other
  * RC2 modes, more of the code will be uncommented. */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -150,7 +152,7 @@
 		RC2_set_key(&key,16,&(RC2key[n][0]),0 /* or 1024 */);
 
 		RC2_ecb_encrypt(&(RC2plain[n][0]),buf,&key,RC2_ENCRYPT);
-		if (memcmp(&(RC2cipher[n][0]),buf,8) != 0)
+		if (op_memcmp(&(RC2cipher[n][0]),buf,8) != 0)
 			{
 			printf("ecb rc2 error encrypting\n");
 			printf("got     :");
@@ -165,7 +167,7 @@
 			}
 
 		RC2_ecb_encrypt(buf,buf2,&key,RC2_DECRYPT);
-		if (memcmp(&(RC2plain[n][0]),buf2,8) != 0)
+		if (op_memcmp(&(RC2plain[n][0]),buf2,8) != 0)
 			{
 			printf("ecb RC2 error decrypting\n");
 			printf("got     :");
@@ -182,12 +184,12 @@
 
 	if (err == 0) printf("ecb RC2 ok\n");
 #ifdef undef
-	memcpy(iv,k,8);
+	op_memcpy(iv,k,8);
 	idea_cbc_encrypt((unsigned char *)text,out,strlen(text)+1,&key,iv,1);
-	memcpy(iv,k,8);
+	op_memcpy(iv,k,8);
 	idea_cbc_encrypt(out,out,8,&dkey,iv,0);
 	idea_cbc_encrypt(&(out[8]),&(out[8]),strlen(text)+1-8,&dkey,iv,0);
-	if (memcmp(text,out,strlen(text)+1) != 0)
+	if (op_memcmp(text,out,strlen(text)+1) != 0)
 		{
 		printf("cbc idea bad\n");
 		err=4;
@@ -220,28 +222,28 @@
 
         idea_set_encrypt_key(cfb_key,&eks);
         idea_set_decrypt_key(&eks,&dks);
-        memcpy(cfb_tmp,cfb_iv,8);
+        op_memcpy(cfb_tmp,cfb_iv,8);
         n=0;
         idea_cfb64_encrypt(plain,cfb_buf1,(long)12,&eks,
                 cfb_tmp,&n,IDEA_ENCRYPT);
         idea_cfb64_encrypt(&(plain[12]),&(cfb_buf1[12]),
                 (long)CFB_TEST_SIZE-12,&eks,
                 cfb_tmp,&n,IDEA_ENCRYPT);
-        if (memcmp(cfb_cipher,cfb_buf1,CFB_TEST_SIZE) != 0)
+        if (op_memcmp(cfb_cipher,cfb_buf1,CFB_TEST_SIZE) != 0)
                 {
                 err=1;
                 printf("idea_cfb64_encrypt encrypt error\n");
                 for (i=0; i<CFB_TEST_SIZE; i+=8)
                         printf("%s\n",pt(&(cfb_buf1[i])));
                 }
-        memcpy(cfb_tmp,cfb_iv,8);
+        op_memcpy(cfb_tmp,cfb_iv,8);
         n=0;
         idea_cfb64_encrypt(cfb_buf1,cfb_buf2,(long)17,&eks,
                 cfb_tmp,&n,IDEA_DECRYPT);
         idea_cfb64_encrypt(&(cfb_buf1[17]),&(cfb_buf2[17]),
                 (long)CFB_TEST_SIZE-17,&dks,
                 cfb_tmp,&n,IDEA_DECRYPT);
-        if (memcmp(plain,cfb_buf2,CFB_TEST_SIZE) != 0)
+        if (op_memcmp(plain,cfb_buf2,CFB_TEST_SIZE) != 0)
                 {
                 err=1;
                 printf("idea_cfb_encrypt decrypt error\n");
diff -Naur openssl-1.0.0q.orig/crypto/rc2/tab.c openssl-1.0.0q/crypto/rc2/tab.c
--- openssl-1.0.0q.orig/crypto/rc2/tab.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/tab.c	2017-04-25 16:23:40.625621130 +0200
@@ -1,4 +1,6 @@
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 unsigned char ebits_to_num[256]={
 	0xbd,0x56,0xea,0xf2,0xa2,0xf1,0xac,0x2a,
diff -Naur openssl-1.0.0q.orig/crypto/rc4/.gitignore openssl-1.0.0q/crypto/rc4/.gitignore
--- openssl-1.0.0q.orig/crypto/rc4/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/rc4/.gitignore	2017-04-25 16:23:40.625621130 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/rc4/rc4.c openssl-1.0.0q/crypto/rc4/rc4.c
--- openssl-1.0.0q.orig/crypto/rc4/rc4.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc4/rc4.c	2017-04-25 16:23:40.627620267 +0200
@@ -56,9 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/rc4.h>
 #include <openssl/evp.h>
 
@@ -85,17 +90,17 @@
 	argv++;
 	while (argc >= 1)
 		{
-		if 	(strcmp(*argv,"-in") == 0)
+		if 	(op_strcmp(*argv,"-in") == 0)
 			{
 			if (--argc < 1) goto bad;
 			infile= *(++argv);
 			}
-		else if (strcmp(*argv,"-out") == 0)
+		else if (op_strcmp(*argv,"-out") == 0)
 			{
 			if (--argc < 1) goto bad;
 			outfile= *(++argv);
 			}
-		else if (strcmp(*argv,"-key") == 0)
+		else if (op_strcmp(*argv,"-key") == 0)
 			{
 			if (--argc < 1) goto bad;
 			keystr= *(++argv);
@@ -145,7 +150,9 @@
 #ifdef OPENSSL_SYS_MSDOS
 	/* This should set the file to binary mode. */
 	{
+#ifndef OPERA_SMALL_VERSION
 #include <fcntl.h>
+#endif /* !OPERA_SMALL_VERSION */
 	setmode(fileno(in),O_BINARY);
 	setmode(fileno(out),O_BINARY);
 	}
diff -Naur openssl-1.0.0q.orig/crypto/rc4/rc4_locl.h openssl-1.0.0q/crypto/rc4/rc4_locl.h
--- openssl-1.0.0q.orig/crypto/rc4/rc4_locl.h	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc4/rc4_locl.h	2017-04-25 16:23:40.627620267 +0200
@@ -1,5 +1,5 @@
 #ifndef HEADER_RC4_LOCL_H
 #define HEADER_RC4_LOCL_H
 #include <openssl/opensslconf.h>
-#include <cryptlib.h>
+#include <openssl/cryptlib.h>
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/rc4/rc4_skey.c openssl-1.0.0q/crypto/rc4/rc4_skey.c
--- openssl-1.0.0q.orig/crypto/rc4/rc4_skey.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rc4/rc4_skey.c	2017-04-25 16:23:40.628620115 +0200
@@ -60,8 +60,11 @@
 #include "rc4_locl.h"
 #include <openssl/opensslv.h>
 
-const char RC4_version[]="RC4" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char RC4_version[]="RC4" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 const char *RC4_options(void)
 	{
 #ifdef RC4_INDEX
@@ -76,6 +79,7 @@
 		return("rc4(ptr,int)");
 #endif
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 /* RC4 as implemented from a posting from
  * Newsgroups: sci.crypt
diff -Naur openssl-1.0.0q.orig/crypto/rc4/rc4s.cpp openssl-1.0.0q/crypto/rc4/rc4s.cpp
--- openssl-1.0.0q.orig/crypto/rc4/rc4s.cpp	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc4/rc4s.cpp	2017-04-25 16:23:40.629621359 +0200
@@ -30,8 +30,10 @@
 }
 #endif      
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif // !OPERA_SMALL_VERSION
 #include <openssl/rc4.h>
 
 void main(int argc,char *argv[])
@@ -46,7 +48,7 @@
 	int j=0;
 
 	if (argc >= 2)
-		num=atoi(argv[1]);
+		num=op_atoi(argv[1]);
 
 	if (num == 0) num=256;
 	if (num > 1024-16) num=1024-16;
diff -Naur openssl-1.0.0q.orig/crypto/rc4/rc4speed.c openssl-1.0.0q/crypto/rc4/rc4speed.c
--- openssl-1.0.0q.orig/crypto/rc4/rc4speed.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rc4/rc4speed.c	2017-04-25 16:23:40.629621359 +0200
@@ -63,7 +63,9 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 #include OPENSSL_UNISTD_IO
@@ -74,10 +76,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -95,7 +101,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
diff -Naur openssl-1.0.0q.orig/crypto/rc4/rc4test.c openssl-1.0.0q/crypto/rc4/rc4test.c
--- openssl-1.0.0q.orig/crypto/rc4/rc4test.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rc4/rc4test.c	2017-04-25 16:23:40.630620928 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -123,9 +125,9 @@
 	for (i=0; i<6; i++)
 		{
 		RC4_set_key(&key,keys[i][0],&(keys[i][1]));
-		memset(obuf,0x00,sizeof(obuf));
+		op_memset(obuf,0x00,sizeof(obuf));
 		RC4(&key,data_len[i],&(data[i][0]),obuf);
-		if (memcmp(obuf,output[i],data_len[i]+1) != 0)
+		if (op_memcmp(obuf,output[i],data_len[i]+1) != 0)
 			{
 			printf("error calculating RC4\n");
 			printf("output:");
@@ -146,9 +148,9 @@
 	for (i=0; i<data_len[3]; i++)
 		{
 		RC4_set_key(&key,keys[3][0],&(keys[3][1]));
-		memset(obuf,0x00,sizeof(obuf));
+		op_memset(obuf,0x00,sizeof(obuf));
 		RC4(&key,i,&(data[3][0]),obuf);
-		if ((memcmp(obuf,output[3],i) != 0) || (obuf[i] != 0))
+		if ((op_memcmp(obuf,output[3],i) != 0) || (obuf[i] != 0))
 			{
 			printf("error in RC4 length processing\n");
 			printf("output:");
@@ -173,10 +175,10 @@
 	for (i=0; i<data_len[3]; i++)
 		{
 		RC4_set_key(&key,keys[3][0],&(keys[3][1]));
-		memset(obuf,0x00,sizeof(obuf));
+		op_memset(obuf,0x00,sizeof(obuf));
 		RC4(&key,i,&(data[3][0]),obuf);
 		RC4(&key,data_len[3]-i,&(data[3][i]),&(obuf[i]));
-		if (memcmp(obuf,output[3],data_len[3]+1) != 0)
+		if (op_memcmp(obuf,output[3],data_len[3]+1) != 0)
 			{
 			printf("error in RC4 multi-call processing\n");
 			printf("output:");
diff -Naur openssl-1.0.0q.orig/crypto/rc5/.gitignore openssl-1.0.0q/crypto/rc5/.gitignore
--- openssl-1.0.0q.orig/crypto/rc5/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/rc5/.gitignore	2017-04-25 16:23:40.631621055 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/rc5/rc5_enc.c openssl-1.0.0q/crypto/rc5/rc5_enc.c
--- openssl-1.0.0q.orig/crypto/rc5/rc5_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc5/rc5_enc.c	2017-04-25 16:23:40.632621461 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/rc5.h>
 #include "rc5_locl.h"
 
diff -Naur openssl-1.0.0q.orig/crypto/rc5/rc5_locl.h openssl-1.0.0q/crypto/rc5/rc5_locl.h
--- openssl-1.0.0q.orig/crypto/rc5/rc5_locl.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rc5/rc5_locl.h	2017-04-25 16:23:40.633621309 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #undef c2l
 #define c2l(c,l)	(l =((unsigned long)(*((c)++)))    , \
diff -Naur openssl-1.0.0q.orig/crypto/rc5/rc5s.cpp openssl-1.0.0q/crypto/rc5/rc5s.cpp
--- openssl-1.0.0q.orig/crypto/rc5/rc5s.cpp	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc5/rc5s.cpp	2017-04-25 16:23:40.633621309 +0200
@@ -30,8 +30,10 @@
 }
 #endif      
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif // !OPERA_SMALL_VERSION
 #include <openssl/rc5.h>
 
 void main(int argc,char *argv[])
diff -Naur openssl-1.0.0q.orig/crypto/rc5/rc5speed.c openssl-1.0.0q/crypto/rc5/rc5speed.c
--- openssl-1.0.0q.orig/crypto/rc5/rc5speed.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rc5/rc5speed.c	2017-04-25 16:23:40.634620598 +0200
@@ -63,7 +63,9 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 #include OPENSSL_UNISTD_IO
@@ -74,10 +76,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -95,7 +101,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
diff -Naur openssl-1.0.0q.orig/crypto/rc5/rc5test.c openssl-1.0.0q/crypto/rc5/rc5test.c
--- openssl-1.0.0q.orig/crypto/rc5/rc5test.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc5/rc5test.c	2017-04-25 16:23:40.635620725 +0200
@@ -59,9 +59,11 @@
 /* This has been a quickly hacked 'ideatest.c'.  When I add tests for other
  * RC5 modes, more of the code will be uncommented. */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -245,7 +247,7 @@
 		RC5_32_set_key(&key,16,&(RC5key[n][0]),12);
 
 		RC5_32_ecb_encrypt(&(RC5plain[n][0]),buf,&key,RC5_ENCRYPT);
-		if (memcmp(&(RC5cipher[n][0]),buf,8) != 0)
+		if (op_memcmp(&(RC5cipher[n][0]),buf,8) != 0)
 			{
 			printf("ecb RC5 error encrypting (%d)\n",n+1);
 			printf("got     :");
@@ -260,7 +262,7 @@
 			}
 
 		RC5_32_ecb_encrypt(buf,buf2,&key,RC5_DECRYPT);
-		if (memcmp(&(RC5plain[n][0]),buf2,8) != 0)
+		if (op_memcmp(&(RC5plain[n][0]),buf2,8) != 0)
 			{
 			printf("ecb RC5 error decrypting (%d)\n",n+1);
 			printf("got     :");
@@ -283,11 +285,11 @@
 
 		RC5_32_set_key(&key,rc5_cbc_key[n][0],&(rc5_cbc_key[n][1]),i);
 
-		memcpy(ivb,&(rc5_cbc_iv[n][0]),8);
+		op_memcpy(ivb,&(rc5_cbc_iv[n][0]),8);
 		RC5_32_cbc_encrypt(&(rc5_cbc_plain[n][0]),buf,8,
 			&key,&(ivb[0]),RC5_ENCRYPT);
 
-		if (memcmp(&(rc5_cbc_cipher[n][0]),buf,8) != 0)
+		if (op_memcmp(&(rc5_cbc_cipher[n][0]),buf,8) != 0)
 			{
 			printf("cbc RC5 error encrypting (%d)\n",n+1);
 			printf("got     :");
@@ -301,10 +303,10 @@
 			printf("\n");
 			}
 
-		memcpy(ivb,&(rc5_cbc_iv[n][0]),8);
+		op_memcpy(ivb,&(rc5_cbc_iv[n][0]),8);
 		RC5_32_cbc_encrypt(buf,buf2,8,
 			&key,&(ivb[0]),RC5_DECRYPT);
-		if (memcmp(&(rc5_cbc_plain[n][0]),buf2,8) != 0)
+		if (op_memcmp(&(rc5_cbc_plain[n][0]),buf2,8) != 0)
 			{
 			printf("cbc RC5 error decrypting (%d)\n",n+1);
 			printf("got     :");
@@ -332,28 +334,28 @@
 
         idea_set_encrypt_key(cfb_key,&eks);
         idea_set_decrypt_key(&eks,&dks);
-        memcpy(cfb_tmp,cfb_iv,8);
+        op_memcpy(cfb_tmp,cfb_iv,8);
         n=0;
         idea_cfb64_encrypt(plain,cfb_buf1,(long)12,&eks,
                 cfb_tmp,&n,IDEA_ENCRYPT);
         idea_cfb64_encrypt(&(plain[12]),&(cfb_buf1[12]),
                 (long)CFB_TEST_SIZE-12,&eks,
                 cfb_tmp,&n,IDEA_ENCRYPT);
-        if (memcmp(cfb_cipher,cfb_buf1,CFB_TEST_SIZE) != 0)
+        if (op_memcmp(cfb_cipher,cfb_buf1,CFB_TEST_SIZE) != 0)
                 {
                 err=1;
                 printf("idea_cfb64_encrypt encrypt error\n");
                 for (i=0; i<CFB_TEST_SIZE; i+=8)
                         printf("%s\n",pt(&(cfb_buf1[i])));
                 }
-        memcpy(cfb_tmp,cfb_iv,8);
+        op_memcpy(cfb_tmp,cfb_iv,8);
         n=0;
         idea_cfb64_encrypt(cfb_buf1,cfb_buf2,(long)17,&eks,
                 cfb_tmp,&n,IDEA_DECRYPT);
         idea_cfb64_encrypt(&(cfb_buf1[17]),&(cfb_buf2[17]),
                 (long)CFB_TEST_SIZE-17,&dks,
                 cfb_tmp,&n,IDEA_DECRYPT);
-        if (memcmp(plain,cfb_buf2,CFB_TEST_SIZE) != 0)
+        if (op_memcmp(plain,cfb_buf2,CFB_TEST_SIZE) != 0)
                 {
                 err=1;
                 printf("idea_cfb_encrypt decrypt error\n");
diff -Naur openssl-1.0.0q.orig/crypto/ripemd/.gitignore openssl-1.0.0q/crypto/ripemd/.gitignore
--- openssl-1.0.0q.orig/crypto/ripemd/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/ripemd/.gitignore	2017-04-25 16:23:40.636620852 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/ripemd/asm/rips.cpp openssl-1.0.0q/crypto/ripemd/asm/rips.cpp
--- openssl-1.0.0q.orig/crypto/ripemd/asm/rips.cpp	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ripemd/asm/rips.cpp	2017-04-25 16:23:40.637620979 +0200
@@ -30,8 +30,10 @@
 }
 #endif      
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif // !OPERA_SMALL_VERSION
 #include <openssl/ripemd.h>
 
 #define ripemd160_block_x86 ripemd160_block_asm_host_order
@@ -52,7 +54,7 @@
 	int j=0;
 
 	if (argc >= 2)
-		num=atoi(argv[1]);
+		num=op_atoi(argv[1]);
 
 	if (num == 0) num=16;
 	if (num > 250) num=16;
diff -Naur openssl-1.0.0q.orig/crypto/ripemd/rmd160.c openssl-1.0.0q/crypto/ripemd/rmd160.c
--- openssl-1.0.0q.orig/crypto/ripemd/rmd160.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/ripemd/rmd160.c	2017-04-25 16:23:40.638621386 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/ripemd.h>
 
 #define BUFSIZE	1024*16
diff -Naur openssl-1.0.0q.orig/crypto/ripemd/rmd_dgst.c openssl-1.0.0q/crypto/ripemd/rmd_dgst.c
--- openssl-1.0.0q.orig/crypto/ripemd/rmd_dgst.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ripemd/rmd_dgst.c	2017-04-25 16:23:40.639620954 +0200
@@ -56,11 +56,17 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPENSSL_NO_RIPEMD
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "rmd_locl.h"
 #include <openssl/opensslv.h>
 
-const char RMD160_version[]="RIPE-MD160" OPENSSL_VERSION_PTEXT;
+
+
+const char RMD160_version[]="RIPE-MD160" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-27 haavardm */
 
 #  ifdef RMD160_ASM
      void ripemd160_block_x86(RIPEMD160_CTX *c, unsigned long *p,size_t num);
@@ -289,3 +295,5 @@
 		}
 	}
 #endif
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/ripemd/rmd_locl.h openssl-1.0.0q/crypto/ripemd/rmd_locl.h
--- openssl-1.0.0q.orig/crypto/ripemd/rmd_locl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/ripemd/rmd_locl.h	2017-04-25 16:23:40.640621640 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/opensslconf.h>
 #include <openssl/ripemd.h>
 
@@ -96,7 +98,7 @@
 	} while (0)
 #define HASH_BLOCK_DATA_ORDER   ripemd160_block_data_order
 
-#include "md32_common.h"
+#include <openssl/md32_common.h>
 
 #if 0
 #define F1(x,y,z)	 ((x)^(y)^(z))
diff -Naur openssl-1.0.0q.orig/crypto/ripemd/rmd_one.c openssl-1.0.0q/crypto/ripemd/rmd_one.c
--- openssl-1.0.0q.orig/crypto/ripemd/rmd_one.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ripemd/rmd_one.c	2017-04-25 16:23:40.640621640 +0200
@@ -56,8 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPENSSL_NO_RIPEMD
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/ripemd.h>
 #include <openssl/crypto.h>
 
@@ -76,3 +80,4 @@
 	return(md);
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/ripemd/rmdtest.c openssl-1.0.0q/crypto/ripemd/rmdtest.c
--- openssl-1.0.0q.orig/crypto/ripemd/rmdtest.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/ripemd/rmdtest.c	2017-04-25 16:23:40.641621767 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -113,11 +115,11 @@
 	while (*P != NULL)
 		{
 #ifdef CHARSET_EBCDIC
-		ebcdic2ascii((char *)*P, (char *)*P, strlen((char *)*P));
+		ebcdic2ascii((char *)*P, (char *)*P, op_strlen((char *)*P));
 #endif
 		EVP_Digest(&(P[0][0]),strlen((char *)*P),md,NULL,EVP_ripemd160(), NULL);
 		p=pt(md);
-		if (strcmp(p,(char *)*R) != 0)
+		if (op_strcmp(p,(char *)*R) != 0)
 			{
 			printf("error calculating RIPEMD160 on '%s'\n",*P);
 			printf("got %s instead of %s\n",p,*R);
@@ -139,7 +141,7 @@
 	static char buf[80];
 
 	for (i=0; i<RIPEMD160_DIGEST_LENGTH; i++)
-		sprintf(&(buf[i*2]),"%02x",md[i]);
+		op_sprintf(&(buf[i*2]),"%02x",md[i]);
 	return(buf);
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/rsa/.gitignore openssl-1.0.0q/crypto/rsa/.gitignore
--- openssl-1.0.0q.orig/crypto/rsa/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/.gitignore	2017-04-25 16:23:40.642621056 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa.h openssl-1.0.0q/crypto/rsa/rsa.h
--- openssl-1.0.0q.orig/crypto/rsa/rsa.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa.h	2017-04-25 16:23:40.647621412 +0200
@@ -153,11 +153,13 @@
 	BN_MONT_CTX *_method_mod_p;
 	BN_MONT_CTX *_method_mod_q;
 
+#if !defined(OPERA_SMALL_VERSION) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 	/* all BIGNUM values are actually in the following data, if it is not
 	 * NULL */
 	char *bignum_data;
 	BN_BLINDING *blinding;
 	BN_BLINDING *mt_blinding;
+#endif
 	};
 
 #ifndef OPENSSL_RSA_MAX_MODULUS_BITS
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_ameth.c openssl-1.0.0q/crypto/rsa/rsa_ameth.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_ameth.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_ameth.c	2017-04-25 16:23:40.648621540 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/rsa.h>
@@ -65,7 +68,9 @@
 #ifndef OPENSSL_NO_CMS
 #include <openssl/cms.h>
 #endif
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 static int rsa_pub_encode(X509_PUBKEY *pk, const EVP_PKEY *pkey)
 	{
@@ -182,7 +187,7 @@
 
 static int do_rsa_print(BIO *bp, const RSA *x, int off, int priv)
 	{
-	char *str;
+	const char *str;
 	const char *s;
 	unsigned char *m=NULL;
 	int ret=0, mod_len = 0;
@@ -274,12 +279,12 @@
 
 		case ASN1_PKEY_CTRL_PKCS7_SIGN:
 		if (arg1 == 0)
-			PKCS7_SIGNER_INFO_get0_algs(arg2, NULL, NULL, &alg);
+			PKCS7_SIGNER_INFO_get0_algs((PKCS7_SIGNER_INFO *)arg2, NULL, NULL, &alg);
 		break;
 
 		case ASN1_PKEY_CTRL_PKCS7_ENCRYPT:
 		if (arg1 == 0)
-			PKCS7_RECIP_INFO_get0_alg(arg2, &alg);
+			PKCS7_RECIP_INFO_get0_alg((PKCS7_RECIP_INFO *)arg2, &alg);
 		break;
 #ifndef OPENSSL_NO_CMS
 		case ASN1_PKEY_CTRL_CMS_SIGN:
@@ -311,15 +316,13 @@
 	}
 
 
-const EVP_PKEY_ASN1_METHOD rsa_asn1_meths[] = 
-	{
-		{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(rsa_ameth__rsa_asn1_meth0,
 		EVP_PKEY_RSA,
 		EVP_PKEY_RSA,
 		ASN1_PKEY_SIGPARAM_NULL,
 
-		"RSA",
-		"OpenSSL RSA method",
+		(char *)"RSA",
+		(char *)"OpenSSL RSA method",
 
 		rsa_pub_decode,
 		rsa_pub_encode,
@@ -339,11 +342,14 @@
 		rsa_pkey_ctrl,
 		old_rsa_priv_decode,
 		old_rsa_priv_encode
-		},
+		);
 
-		{
+CONST_EVP_PKEY_ASN1_METHOD_ITEM(rsa_ameth__rsa_asn1_meth1,
 		EVP_PKEY_RSA2,
 		EVP_PKEY_RSA,
 		ASN1_PKEY_ALIAS
-		}
-	};
+		// 21 zeros.
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+		, 0
+		);
diff -Naur openssl-1.0.0q.orig/crypto/rsa/rsa_asn1.c openssl-1.0.0q/crypto/rsa/rsa_asn1.c
--- openssl-1.0.0q.orig/crypto/rsa/rsa_asn1.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rsa/rsa_asn1.c	2017-04-25 16:23:40.649621108 +0200
@@ -56,11 +56,15 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/bn.h>
 #include <openssl/rsa.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Override the default free and new methods */
 static int rsa_cb(int operation, ASN1_VALUE **pval, const ASN1_ITEM *it,
@@ -78,23 +82,22 @@
 	return 1;
 }
 
-ASN1_SEQUENCE_cb(RSAPrivateKey, rsa_cb) = {
-	ASN1_SIMPLE(RSA, version, LONG),
-	ASN1_SIMPLE(RSA, n, BIGNUM),
-	ASN1_SIMPLE(RSA, e, BIGNUM),
-	ASN1_SIMPLE(RSA, d, BIGNUM),
-	ASN1_SIMPLE(RSA, p, BIGNUM),
-	ASN1_SIMPLE(RSA, q, BIGNUM),
-	ASN1_SIMPLE(RSA, dmp1, BIGNUM),
-	ASN1_SIMPLE(RSA, dmq1, BIGNUM),
+ASN1_SEQUENCE_cb(RSAPrivateKey, rsa_cb)
+	ASN1_SIMPLE(RSA, version, LONG)
+	ASN1_SIMPLE(RSA, n, BIGNUM)
+	ASN1_SIMPLE(RSA, e, BIGNUM)
+	ASN1_SIMPLE(RSA, d, BIGNUM)
+	ASN1_SIMPLE(RSA, p, BIGNUM)
+	ASN1_SIMPLE(RSA, q, BIGNUM)
+	ASN1_SIMPLE(RSA, dmp1, BIGNUM)
+	ASN1_SIMPLE(RSA, dmq1, BIGNUM)
 	ASN1_SIMPLE(RSA, iqmp, BIGNUM)
-} ASN1_SEQUENCE_END_cb(RSA, RSAPrivateKey)
-
+ASN1_SEQUENCE_END_cb(RSA, RSAPrivateKey)
 
-ASN1_SEQUENCE_cb(RSAPublicKey, rsa_cb) = {
-	ASN1_SIMPLE(RSA, n, BIGNUM),
-	ASN1_SIMPLE(RSA, e, BIGNUM),
-} ASN1_SEQUENCE_END_cb(RSA, RSAPublicKey)
+ASN1_SEQUENCE_cb(RSAPublicKey, rsa_cb)
+	ASN1_SIMPLE(RSA, n, BIGNUM)
+	ASN1_SIMPLE(RSA, e, BIGNUM)
+ASN1_SEQUENCE_END_cb(RSA, RSAPublicKey)
 
 IMPLEMENT_ASN1_ENCODE_FUNCTIONS_const_fname(RSA, RSAPrivateKey, RSAPrivateKey)
 
@@ -102,10 +105,10 @@
 
 RSA *RSAPublicKey_dup(RSA *rsa)
 	{
-	return ASN1_item_dup(ASN1_ITEM_rptr(RSAPublicKey), rsa);
+	return (RSA*)ASN1_item_dup(ASN1_ITEM_rptr(RSAPublicKey), rsa);
 	}
 
 RSA *RSAPrivateKey_dup(RSA *rsa)
 	{
-	return ASN1_item_dup(ASN1_ITEM_rptr(RSAPrivateKey), rsa);
+	return (RSA*)ASN1_item_dup(ASN1_ITEM_rptr(RSAPrivateKey), rsa);
 	}
